class RNG {
	private seed: number;

	constructor(seed: number) {
		this.seed = seed;
	}

	private static readonly A: number = 1664525;
    private static readonly C: number = 1013904223;
    private static readonly MOD: number = Math.pow(2, 32);

	// Returns a floating point num from 0 to 1
	next(): number {
		this.seed = (RNG.A * this.seed + RNG.C) % RNG.MOD;
		return this.seed / RNG.MOD;
	}

	nextInt(min: number, max: number): number {
		return Math.floor(this.next() * (max - min + 1)) + min;
	}

	next255(): number {
		return Math.floor(this.next() * 255);
	}
}

export default RNG;