class Chip8Audio {
	audioBrowserContext: AudioContext | null;
	oscillator: OscillatorNode | null;
	gainNode: GainNode | null;

	volume: number;

	constructor() {
		this.audioBrowserContext = null;
		this.oscillator = null;
		this.gainNode = null;
		this.volume = 0.1;
	}

	startAudio(audioContext: AudioContext, volume: number) {
		this.volume = volume;
		this.audioBrowserContext = audioContext;
		this.gainNode = this.audioBrowserContext.createGain();
		this.gainNode.connect(this.audioBrowserContext.destination);
		this.gainNode.gain.setValueAtTime(this.volume, this.audioBrowserContext.currentTime);
	}

	startBeep() {
		if(this.oscillator == null && this.audioBrowserContext && this.gainNode) {
			this.oscillator = this.audioBrowserContext.createOscillator();
			this.oscillator.type = 'square';
			this.oscillator.frequency.setValueAtTime(440, this.audioBrowserContext.currentTime); // 440 Hz (A4 note)
			this.oscillator.connect(this.gainNode);
			this.oscillator.start();
		}
	}

	stopBeep() {
		if(this.oscillator) {
			this.oscillator.stop();
			this.oscillator = null;
		}
	}
}

export default Chip8Audio;
