import path from 'path';
import { fileURLToPath } from 'url';

const __filename = fileURLToPath(import.meta.url);
const __dirname = path.dirname(__filename);

export default {
	entry: './src/index.ts',
	output: {
		filename: 'revuelto8ts.js',
		path: path.resolve(__dirname, 'dist'),
		library: {
			name: 'Revuelto8ts',
			type: 'umd',
			export: 'default',
		},
		globalObject: 'this'
	},
	mode: 'production',
	resolve: {
		extensions: ['.ts', '.tsx', '.js'],
	},
	module: {
		rules: [
			{
				test: /\.tsx?$/,
				use: 'ts-loader',
				exclude: /node_modules/,
			},
		],
	}
};
